<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
  <button class="btn btn-primary" (click)="nuevo()">
    <i class="fas fa-plus mr-2"></i>Nuevo
  </button>
  <button class="btn btn-success ml-1" [disabled]="ngForm.invalid" (click)="guardar(ngForm.value)">
    <i class="fas fa-save mr-2"></i>Guardar
  </button>
</app-page-title>

<div class="card mb-3 animated fadeIn">
  <div class="card-body">

      <form [formGroup]="ngForm">
        <div class="row">
          <div class="form-group col-12">
            <label>Descripción</label>
            <input type="text" class="form-control" formControlName="nDesc" #first>
          </div>
        </div>
      </form>

      <kendo-grid [data]="dataGrid" [selectable]="true" (selectionChange)="selectedRowDet($event)"
        [kendoGridSelectBy]="'nEent'" [selectedKeys]="ngFormSelection" style="height: 64vh;">
        <ng-container *ngIf="dataGrid.length !== 0">
          <kendo-grid-column field="nEent" title="Entrada"></kendo-grid-column>
          <kendo-grid-column field="nDesc" title="Descripción"></kendo-grid-column>
          <kendo-grid-column field="nOpe" title="Operador"></kendo-grid-column>
          <kendo-grid-command-column width="250">
            <ng-template kendoGridCellTemplate let-dataItem>
              <button class="btn btn-info" (click)="detalle(modalForm, dataItem)">
                <i class="fas fa-ellipsis-v mr-2"></i>Detalle
              </button>
              <button class="btn btn-danger ml-1" (click)="eliminar(dataItem)">
                <i class="fas fa-trash-alt mr-2"></i>Eliminar
              </button>
            </ng-template>
          </kendo-grid-command-column>
        </ng-container>
        <ng-template kendoGridNoRecordsTemplate>
          {{ noRecords }}
        </ng-template>
      </kendo-grid>

    <ngx-loading [show]="loading" [config]="loadingColor"></ngx-loading>

    <ng-template #modalForm let-c="close" let-d="dismiss" class="animated flipInX">
      <div class="modal-header">
        <div class="modal-title">
          <i class="fas fa-ellipsis-v mr-2"></i> DETALLES {{ ngForm.value.nDesc }} - ENTRADA {{ ngForm.value.nEent }}
        </div>
        <button class="close" aria-label="Close" (click)="d('Cross click')">
          <span aria-hidden="true">&times;</span>
        </button>
      </div>
      <div class="modal-body">
        <form [formGroup]="ngForm2">
          <div class="row">
            <div class="col-12 d-flex justify-content-end">
              <button class="btn btn-primary" (click)="nuevoDetalle()">
                <i class="fas fa-plus mr-2"></i>Nuevo
              </button>
              <button class="btn btn-success ml-1" [disabled]="ngForm.invalid" (click)="guardarDetalle(ngForm2.value)">
                <i class="fas fa-save mr-2"></i>Guardar
              </button>
            </div>

            <div class="divider"></div>

            <div class="col-5">
              <label for="Codigo">Código</label>
              <kendo-combobox [data]="dsCodigos" [textField]="'cdesc'" [valueField]="'Codigo'" [filterable]="true"
                formControlName="Codigo" [valuePrimitive]="true" class="w-100" [readonly]="!flagNuevoDetalle">
              </kendo-combobox>
            </div>
            <div class="form-group col">
              <label>Monto</label>
              <input type="number" class="form-control" formControlName="nMonto" [readOnly]="!flagNuevoDetalle">
            </div>
            <div class="form-group col">
              <label>Servicio</label>
              <input type="number" class="form-control" formControlName="nProp" [readOnly]="!flagNuevoDetalle">
            </div>
            <div class="form-group col text-right">
              <label for="">Balance</label>
              <div class="widget-numbers text-success h3">
                <strong>{{ balance | number:'.2-2' }}</strong>
              </div>
            </div>
          </div>
          <div class="divider"></div>
          <kendo-grid [data]="dataGridDet" [selectable]="true" (selectionChange)="selectedRow($event)"
            style="height: 42vh;">
            <ng-container *ngIf="dataGridDet.length !== 0">
              <kendo-grid-column field="Codigo" title="Código"></kendo-grid-column>
              <kendo-grid-column field="nMonto" title="Monto" class="text-right">
                <ng-template kendoGridCellTemplate let-dataItem>
                  {{ dataItem.nMonto | currency: 'MXN' }}
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-column field="nProp" title="Servicio" class="text-right">
                <ng-template kendoGridCellTemplate let-dataItem>
                  {{ dataItem.nProp | currency: 'MXN' }}
                </ng-template>
              </kendo-grid-column>
              <kendo-grid-command-column width="140">
                <ng-template kendoGridCellTemplate let-dataItem>
                  <button class="btn btn-danger" (click)="eliminarDetalle(dataItem)">
                    <i class="fas fa-trash-alt mr-2"></i>Eliminar
                  </button>
                </ng-template>
              </kendo-grid-command-column>
            </ng-container>
            <ng-template kendoGridNoRecordsTemplate>
              {{ noRecords }}
            </ng-template>
          </kendo-grid>
        </form>
      </div>
      <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c('Close click');">
          Cerrar
        </button>
      </div>
    </ng-template>
  </div>
</div>